### WILLIAMS ###

#Load data for each iteration and set n for pairs of comparisons
boot10 <- read.csv("bootstrap_n-10_iterations-1000.csv")
boot20 <- read.csv("bootstrap_n-20_iterations-1000.csv")
boot30 <- read.csv("bootstrap_n-30_iterations-1000.csv")
boot40 <- read.csv("bootstrap_n-40_iterations-1000.csv")
boot50 <- read.csv("bootstrap_n-50_iterations-1000.csv")
boot75 <- read.csv("bootstrap_n-75_iterations-1000.csv")
boot100 <- read.csv("bootstrap_n-100_iterations-1000.csv")
boot125 <- read.csv("bootstrap_n-125_iterations-1000.csv")
boot150 <- read.csv("bootstrap_n-150_iterations-1000.csv")
boot200 <- read.csv("bootstrap_n-200_iterations-1000.csv")
boot250 <- read.csv("bootstrap_n-250_iterations-1000.csv")
boot300 <- read.csv("bootstrap_n-300_iterations-1000.csv")
boot <- rbind(boot10, boot20, boot30, boot40, boot50, boot75, boot100, boot125, boot150, boot200, boot250, boot300)

pair1 <- c(10, 20, 30, 40, 50, 75, 100, 125, 150, 200, 250)
pair2 <- c(20, 30, 40, 50, 75, 100, 125, 150, 200, 250, 300)

#create output dataframe
ks_data <- data.frame(matrix(ncol=6,nrow=0, dimnames=list(NULL, c("variable", "model", "n1", "n2", "varcomp", "p.value"))))

#Pair-wise iterations over all variables for Kolmogorov–Smirnov test
for (i in 1:9) { #iterate over all variables
  for (ii in 1:4) { #iterate over all models
    for (iii in 1:length(pair1)) { #iterate all pairs of N
      for (iv in 1:3) { #iterate over all variance components
        pval <- ks.test(subset(boot, variable == i & model == ii & n == pair1[iii] & varcomp == iv)$value, subset(boot, variable == i & model == ii & n == pair2[iii] & varcomp == iv)$value)$p.value
        ks_data <- rbind(ks_data, list(i, ii, pair1[iii], pair2[iii], iv, pval))
      }
    }
  }
}
#Rename columns and remove within-subject variance values for model 4 (because it is not estimated)  
names(ks_data) <- c("variable", "model", "n1", "n2", "varcomp", "p.value")
ks_data <- ks_data[!row.names(ks_data) %in% rownames(subset(ks_data, model == 4 & varcomp == 1)),]

#perform holm correction for each variable and create Boolean for significant pvalues
ks_data$cor.p.value <- NA
for (i in 1:9) {
  ks_data[rownames(subset(ks_data, variable == i)),]$cor.p.value <- p.adjust(subset(ks_data, variable == i)$p.value, method = "holm")
}
ks_data$sig <- ks_data$cor.p.value < 0.05

# save to csv
write.csv(ks_data, "ks_results.csv", row.names = FALSE)

### WALTMANN ###
#clear all variables
rm(list = ls())
#Load data for each iteration and set n for pairs of comparisons
boot10 <- read.csv("bootstrap_n-10_iterations-1000_Waltmann.csv")
boot20 <- read.csv("bootstrap_n-20_iterations-1000_Waltmann.csv")
boot30 <- read.csv("bootstrap_n-30_iterations-1000_Waltmann.csv")
boot40 <- read.csv("bootstrap_n-40_iterations-1000_Waltmann.csv")
boot50 <- read.csv("bootstrap_n-50_iterations-1000_Waltmann.csv")
boot75 <- read.csv("bootstrap_n-75_iterations-1000_Waltmann.csv")
boot100 <- read.csv("bootstrap_n-100_iterations-1000_Waltmann.csv")
boot125 <- read.csv("bootstrap_n-125_iterations-1000_Waltmann.csv")
boot150 <- read.csv("bootstrap_n-150_iterations-1000_Waltmann.csv")
boot200 <- read.csv("bootstrap_n-200_iterations-1000_Waltmann.csv")
boot250 <- read.csv("bootstrap_n-250_iterations-1000_Waltmann.csv")
boot300 <- read.csv("bootstrap_n-300_iterations-1000_Waltmann.csv")
boot <- rbind(boot10, boot20, boot30, boot40, boot50, boot75, boot100, boot125, boot150, boot200, boot250, boot300)

pair1 <- c(10, 20, 30, 40, 50, 75, 100, 125, 150, 200, 250)
pair2 <- c(20, 30, 40, 50, 75, 100, 125, 150, 200, 250, 300)

#create output dataframe
ks_data <- data.frame(matrix(ncol=6,nrow=0, dimnames=list(NULL, c("variable", "model", "n1", "n2", "varcomp", "p.value"))))

#Pair-wise iterations over all variables for Kolmogorov–Smirnov test
for (i in 1:9) { #iterate over all variables
  for (ii in 1:4) { #iterate over all models
    for (iii in 1:length(pair1)) { #iterate all pairs of N
      for (iv in 1:3) { #iterate over all variance components
        pval <- ks.test(subset(boot, variable == i & model == ii & n == pair1[iii] & varcomp == iv)$value, subset(boot, variable == i & model == ii & n == pair2[iii] & varcomp == iv)$value)$p.value
        ks_data <- rbind(ks_data, list(i, ii, pair1[iii], pair2[iii], iv, pval))
      }
    }
  }
}
#Rename columns and remove within-subject variance values for model 4 (because it is not estimated)  
names(ks_data) <- c("variable", "model", "n1", "n2", "varcomp", "p.value")
ks_data <- ks_data[!row.names(ks_data) %in% rownames(subset(ks_data, model == 4 & varcomp == 1)),]

#perform holm correction for each variable and create Boolean for significant pvalues
ks_data$cor.p.value <- NA
for (i in 1:9) {
  ks_data[rownames(subset(ks_data, variable == i)),]$cor.p.value <- p.adjust(subset(ks_data, variable == i)$p.value, method = "holm")
}
ks_data$sig <- ks_data$cor.p.value < 0.05

# save to csv
write.csv(ks_data, "ks_results_waltmann.csv", row.names = FALSE)

### Create output tables ###

# load datasets and create variables to pivot long to wide
df1 <- read.csv("ks_results.csv"); df2 <- read.csv("ks_results_waltmann.csv")
df1$comparison <- paste(df1$n1, df1$n2, sep = "-"); df1$dataset <- "Williams"
df2$comparison <- paste(df2$n1, df2$n2, sep = "-"); df2$dataset <- "Waltmann"
df <- rbind(df1, df2)

# pivot data from long to wide format
library(tidyverse)
df <- df %>%
  pivot_wider(
    names_from = comparison,
    values_from = cor.p.value,
    id_cols = c(variable, model, varcomp, dataset),
    names_sort = TRUE
  )

df <- arrange(df, variable, model, varcomp, desc(dataset))

# rename integers as strings
library(plyr)
df$variable <- mapvalues(df$variable,
                         from = c(1,2,3,4,5,6,7,8,9),
                         to = c("∆ reaction times", "Accuracy", "Perseveration", 
                                "Reaction times after losses", "Reaction times after wins", 
                                "Reaction times overall", "Stay behaviour overall", 
                                "Staying after losses", "Staying after wins"))
df$model <- mapvalues(df$model,
                         from = c(1,2,3,4),
                         to = c("Mean", "Separate", "Joint", "Model calculated"))
df$varcomp <- mapvalues(df$varcomp,
                         from = c(1,2,3),
                         to = c("Within-subject", "Error", "Between-subject"))

# replace non significant p-values with NA, re-order dataframe columns, and assign significance levels
library(naniar)
df <- replace_with_na_at(df, 
                         .vars = c("10-20", "20-30", "30-40", "40-50", "50-75", "75-100", 
                                   "100-125", "125-150", "150-200", "200-250", "250-300"),
                         condition = ~.x >= 0.05)
df <- df[, c("variable", "model", "varcomp", "dataset", "10-20", 
             "20-30", "30-40", "40-50", "50-75", "75-100", "100-125", 
             "125-150", "150-200", "200-250", "250-300")]
df[,5:15] <- replace(df[,5:15], df[,5:15] <= 0.001, 1)
df[,5:15] <- replace(df[,5:15], df[,5:15] > 0.001 & df[,5:15] <= 0.01, 2)
df[,5:15] <- replace(df[,5:15], df[,5:15] > 0.01 & df[,5:15] < 0.05, 3)

df$`10-20` <- mapvalues(df$`10-20`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`20-30` <- mapvalues(df$`20-30`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`30-40` <- mapvalues(df$`30-40`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`40-50` <- mapvalues(df$`40-50`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`50-75` <- mapvalues(df$`50-75`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`75-100` <- mapvalues(df$`75-100`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`100-125` <- mapvalues(df$`100-125`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`125-150` <- mapvalues(df$`125-150`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`150-200` <- mapvalues(df$`150-200`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`200-250` <- mapvalues(df$`200-250`,
                         from = c(1, 2, 3, NA),
                         to = c("***", "**", "*", "N/S"))
df$`250-300` <- mapvalues(df$`250-300`,
                          from = c(1, 2, 3, NA),
                          to = c("***", "**", "*", "N/S"))
write.csv(df, "ks_tables.csv", row.names = FALSE)

### MODELLING DATA ###
library(data.table)

# Load data for each n
boot <- read.csv("relative_variance_bootstrap.csv")

#melt from wide to long
boot <- melt(setDT(boot), id.vars = c("variable","iteration","n","model"), variable.name = "varcomp")
boot$varcomp <- fct_rev(boot$varcomp) # reverse factor to be in line with other figures
boot$varcomp <- as.numeric(boot$varcomp)

#create output dataframe
ks_data <- data.frame(matrix(ncol=6,nrow=0, dimnames=list(NULL, c("variable", "model", "n1", "n2", "varcomp", "p.value"))))

#Pair-wise iterations over all variables for Kolmogorov–Smirnov test
for (i in 1:6) { #iterate over all variables
  for (ii in 1:3) { #iterate over all models
    for (iii in 1:length(pair1)) { #iterate all pairs of N
      for (iv in 1:3) { #iterate over all variance components
        pval <- ks.test(subset(boot, variable == i & model == ii & n == pair1[iii] & varcomp == iv)$value, subset(boot, variable == i & model == ii & n == pair2[iii] & varcomp == iv)$value)$p.value
        ks_data <- rbind(ks_data, list(i, ii, pair1[iii], pair2[iii], iv, pval))
      }
    }
  }
}
#Rename columns and remove within-subject variance values for model 4 (because it is not estimated)  
names(ks_data) <- c("variable", "model", "n1", "n2", "varcomp", "p.value")

#perform holm correction for each variable and create Boolean for significant pvalues
ks_data$cor.p.value <- NA
for (i in 1:9) {
  ks_data[rownames(subset(ks_data, variable == i)),]$cor.p.value <- p.adjust(subset(ks_data, variable == i)$p.value, method = "holm")
}
ks_data$sig <- ks_data$cor.p.value < 0.05

# save to csv
write.csv(ks_data, "ks_results_modelling.csv", row.names = FALSE)

# prepare data for generating table
df <- ks_data
df$comparison <- paste(df$n1, df$n2, sep = "-");
# pivot data from long to wide format
df <- df %>%
  pivot_wider(
    names_from = comparison,
    values_from = cor.p.value,
    id_cols = c(variable, model, varcomp),
    names_sort = TRUE
  )
df <- arrange(df, variable, model, varcomp)

# rename integers as strings
df$variable <- mapvalues(df$variable,
                         from = c(1,2,3,4,5,6),
                         to = c("Reinforcement sensitivity for wins: separate estimation",
                                "Reinforcement sensitivity for wins: joint estimation",
                                "Reinforcement sensitivity for losses: separate estimation",
                                "Reinforcement sensitivity for losses: joint estimation",
                                "Learning rate: separate estimation",
                                "Learning rate: joint estimation"))
df$model <- mapvalues(df$model,
                      from = c(1,2,3),
                      to = c("ML", "MAP0", "EM"))
df$varcomp <- mapvalues(df$varcomp,
                        from = c(1,2,3),
                        to = c("Within-subject", "Error", "Between-subject"))

# replace non significant p-values with NA, re-order dataframe columns, and assign significance levels
df <- replace_with_na_at(df, 
                         .vars = c("10-20", "20-30", "30-40", "40-50", "50-75", "75-100", 
                                   "100-125", "125-150", "150-200", "200-250", "250-300"),
                         condition = ~.x >= 0.05)
df <- df[, c("variable", "model", "varcomp", "10-20", 
             "20-30", "30-40", "40-50", "50-75", "75-100", "100-125", 
             "125-150", "150-200", "200-250", "250-300")]
df[,4:14] <- replace(df[,4:14], df[,4:14] <= 0.001, 1)
df[,4:14] <- replace(df[,4:14], df[,4:14] > 0.001 & df[,4:14] <= 0.01, 2)
df[,4:14] <- replace(df[,4:14], df[,4:14] > 0.01 & df[,4:14] < 0.05, 3)

df$`10-20` <- mapvalues(df$`10-20`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`20-30` <- mapvalues(df$`20-30`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`30-40` <- mapvalues(df$`30-40`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`40-50` <- mapvalues(df$`40-50`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`50-75` <- mapvalues(df$`50-75`,
                        from = c(1, 2, 3, NA),
                        to = c("***", "**", "*", "N/S"))
df$`75-100` <- mapvalues(df$`75-100`,
                         from = c(1, 2, 3, NA),
                         to = c("***", "**", "*", "N/S"))
df$`100-125` <- mapvalues(df$`100-125`,
                          from = c(1, 2, 3, NA),
                          to = c("***", "**", "*", "N/S"))
df$`125-150` <- mapvalues(df$`125-150`,
                          from = c(1, 2, 3, NA),
                          to = c("***", "**", "*", "N/S"))
df$`150-200` <- mapvalues(df$`150-200`,
                          from = c(1, 2, 3, NA),
                          to = c("***", "**", "*", "N/S"))
df$`200-250` <- mapvalues(df$`200-250`,
                          from = c(1, 2, 3, NA),
                          to = c("***", "**", "*", "N/S"))
df$`250-300` <- mapvalues(df$`250-300`,
                          from = c(1, 2, 3, NA),
                          to = c("***", "**", "*", "N/S"))
write.csv(df, "ks_tables_modelling.csv", row.names = FALSE)


### some quick dirty code for visualising cdfs for ks tests ###
# test <- ks.test(subset(boot, variable == 8 & model == 1 & n == pair1[4] & varcomp == 1)$value, subset(boot, variable == 8 & model == 1 & n == pair2[4] & varcomp == 1)$value)
# plot(ecdf(test$data$x), col = "red"); lines(ecdf(test$data$y), col = "green")